# coding: utf-8

"""
    Developer API - DataGalaxy

    # Overview  The DataGalaxy API gives you access to CRUD actions on your metamodel, users and licenses.  Our API is organized around REST. It accepts and returns JSON-encoded data, and uses standard HTTP response codes, verbs and authentication with access tokens.  To get the full picture of DataGalaxy, please feel free to consult our <a href='https://datagalaxy.freshdesk.com/solution/articles/35000131583--basics-datagalaxy-s-main-concepts-/en' target='_new'>online documentation.</a><br/> Have a look at our <a href='https://datagalaxy.freshdesk.com/en/support/solutions/articles/35000151096--quick-start-datagalaxy-public-api-v2' target='_new'>step by step guide</a> for a quick start on how to use our API.  ## Response Status Codes  | Status Code  | Description       | Notes | | ------------ | ----------------- | ----- | | 200          | OK                | The request was successful | | 400          | Bad Request       | Incoming request contains parameters that might not be valid | | 401          | Unauthorized      | The supplied credentials, if any, are not sufficient to access the resource | | 404          | Not Found         | The requested resource is not found | | 429          | Too Many Requests | Too many requests have been (Rate limiting) | | 500          | Server Error      | The server could not return the representation due to an internal server error | | 501          | Not Implemented   | The requested operation is not supported (e.g. supports GET but not POST etc.) |  ## Rate Limits  The DataGalaxy API has 2 kinds of limitations: rate limiting and throttling.  <b>Pro tip:</b> You can track your rate limiting status with the response header `X-RateLimit-Remaining`. It will display how many requests you can send until the next reset.  | Method        | Rate                 | Note | | ------------- | -------------------- | ---- | | Rate limiting | 7200 requests / hour | When exceeded, your IP will be blocked for 15 minutes. | | Throttling    | 2 requests / second  | When exceeded, each request will be delayed by 500ms. | | Payload size  | 100 MB               | When exceeded, request will be rejected. |  ## Pagination  All routes returning lists share the same pagination format. These routes take two optional parameters as querystrings: <code>limit</code> and <code>page</code>.<br>  | QueryString | Definition | |------------ | ---------- | | limit       | Integer ranging from 1 to 5000. It sets the maximum amount of objects per page. Default value is 20. | | page        | Integer starting at 1. It determines the page returned by the request. Default value is 1. |  The response payload contains 5 properties:  | Property  | Definition | | --------- | ---------- | | pages     | Total number of pages. | | total     | Number of objects returned. | | total_sum | Sum of all existing objects. | | next_page | URL of the next page. <i>Value will be null if there is none.</i> | | results   | List of objects. |  # Authentication  The DataGalaxy API uses <b>Bearer Authentication</b> to authenticate requests. Every request must contain an <code>Authorization</code> header with, either an <i>AccessToken</i> or an <i>IntegrationToken</i>.  ## AccessToken  Here is a quick example using CURL:  <pre><code>curl -X GET \"https://api.datagalaxy.com/v2/workspaces\" -H \"Authorization: Bearer <i>AccessToken</i>\"</code></pre>  The first steps of our <a href='https://datagalaxy.freshdesk.com/en/support/solutions/articles/35000151096--quick-start-datagalaxy-public-api-v2' target='_new'>quick start guide</a> will give you instructions to obtain your <code>accesstoken</code>.  ## IntegrationToken  An integration token can be generated from the \"Integration\" page on the DataGalaxy Administration space.  <pre><code>curl -X GET \"https://api.datagalaxy.com/v2/workspaces\" -H \"Authorization: Bearer <i>IntegrationToken</i>\"</code></pre>  # Changelog  The DataGalaxy Developer API is updated frequently with new features, improvements and fixes.  All these changes will be documented in our <button><a href='/v2/documentation/changelog' target='_blank'><b>changelog</b></a></button>.  # Documentation layout  We provide two API documentation layouts:  - [Default layout](/v2/documentation)<br> This layout displays informations in a modern way and contains more informations about requests parameters - [Swagger layout](/v2/documentation/old)<br> This is our legacy layout. It's main perk is the \"Try it\" feature which let's you send requests directly from the documentation.  # noqa: E501

    OpenAPI spec version: 2.12.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class AccessData(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'has_official_role_attributes_write_access': 'bool',
        'has_entity_status_write_access': 'bool',
        'has_suggestion_mode_write_access': 'bool',
        'has_task_write_access': 'bool',
        'has_read_access': 'bool',
        'has_write_access': 'bool',
        'has_administrator_access': 'bool',
        'has_import_access': 'bool',
        'has_export_access': 'bool',
        'has_delete_access': 'bool',
        'has_create_access': 'bool',
        'has_management_access': 'bool'
    }

    attribute_map = {
        'has_official_role_attributes_write_access': 'hasOfficialRoleAttributesWriteAccess',
        'has_entity_status_write_access': 'hasEntityStatusWriteAccess',
        'has_suggestion_mode_write_access': 'hasSuggestionModeWriteAccess',
        'has_task_write_access': 'hasTaskWriteAccess',
        'has_read_access': 'hasReadAccess',
        'has_write_access': 'hasWriteAccess',
        'has_administrator_access': 'hasAdministratorAccess',
        'has_import_access': 'hasImportAccess',
        'has_export_access': 'hasExportAccess',
        'has_delete_access': 'hasDeleteAccess',
        'has_create_access': 'hasCreateAccess',
        'has_management_access': 'hasManagementAccess'
    }

    def __init__(self, has_official_role_attributes_write_access=None, has_entity_status_write_access=None, has_suggestion_mode_write_access=None, has_task_write_access=None, has_read_access=None, has_write_access=None, has_administrator_access=None, has_import_access=None, has_export_access=None, has_delete_access=None, has_create_access=None, has_management_access=None):  # noqa: E501
        """AccessData - a model defined in Swagger"""  # noqa: E501
        self._has_official_role_attributes_write_access = None
        self._has_entity_status_write_access = None
        self._has_suggestion_mode_write_access = None
        self._has_task_write_access = None
        self._has_read_access = None
        self._has_write_access = None
        self._has_administrator_access = None
        self._has_import_access = None
        self._has_export_access = None
        self._has_delete_access = None
        self._has_create_access = None
        self._has_management_access = None
        self.discriminator = None
        self.has_official_role_attributes_write_access = has_official_role_attributes_write_access
        self.has_entity_status_write_access = has_entity_status_write_access
        self.has_suggestion_mode_write_access = has_suggestion_mode_write_access
        self.has_task_write_access = has_task_write_access
        self.has_read_access = has_read_access
        self.has_write_access = has_write_access
        self.has_administrator_access = has_administrator_access
        self.has_import_access = has_import_access
        self.has_export_access = has_export_access
        self.has_delete_access = has_delete_access
        self.has_create_access = has_create_access
        self.has_management_access = has_management_access

    @property
    def has_official_role_attributes_write_access(self):
        """Gets the has_official_role_attributes_write_access of this AccessData.  # noqa: E501


        :return: The has_official_role_attributes_write_access of this AccessData.  # noqa: E501
        :rtype: bool
        """
        return self._has_official_role_attributes_write_access

    @has_official_role_attributes_write_access.setter
    def has_official_role_attributes_write_access(self, has_official_role_attributes_write_access):
        """Sets the has_official_role_attributes_write_access of this AccessData.


        :param has_official_role_attributes_write_access: The has_official_role_attributes_write_access of this AccessData.  # noqa: E501
        :type: bool
        """
        if has_official_role_attributes_write_access is None:
            raise ValueError("Invalid value for `has_official_role_attributes_write_access`, must not be `None`")  # noqa: E501

        self._has_official_role_attributes_write_access = has_official_role_attributes_write_access

    @property
    def has_entity_status_write_access(self):
        """Gets the has_entity_status_write_access of this AccessData.  # noqa: E501


        :return: The has_entity_status_write_access of this AccessData.  # noqa: E501
        :rtype: bool
        """
        return self._has_entity_status_write_access

    @has_entity_status_write_access.setter
    def has_entity_status_write_access(self, has_entity_status_write_access):
        """Sets the has_entity_status_write_access of this AccessData.


        :param has_entity_status_write_access: The has_entity_status_write_access of this AccessData.  # noqa: E501
        :type: bool
        """
        if has_entity_status_write_access is None:
            raise ValueError("Invalid value for `has_entity_status_write_access`, must not be `None`")  # noqa: E501

        self._has_entity_status_write_access = has_entity_status_write_access

    @property
    def has_suggestion_mode_write_access(self):
        """Gets the has_suggestion_mode_write_access of this AccessData.  # noqa: E501


        :return: The has_suggestion_mode_write_access of this AccessData.  # noqa: E501
        :rtype: bool
        """
        return self._has_suggestion_mode_write_access

    @has_suggestion_mode_write_access.setter
    def has_suggestion_mode_write_access(self, has_suggestion_mode_write_access):
        """Sets the has_suggestion_mode_write_access of this AccessData.


        :param has_suggestion_mode_write_access: The has_suggestion_mode_write_access of this AccessData.  # noqa: E501
        :type: bool
        """
        if has_suggestion_mode_write_access is None:
            raise ValueError("Invalid value for `has_suggestion_mode_write_access`, must not be `None`")  # noqa: E501

        self._has_suggestion_mode_write_access = has_suggestion_mode_write_access

    @property
    def has_task_write_access(self):
        """Gets the has_task_write_access of this AccessData.  # noqa: E501


        :return: The has_task_write_access of this AccessData.  # noqa: E501
        :rtype: bool
        """
        return self._has_task_write_access

    @has_task_write_access.setter
    def has_task_write_access(self, has_task_write_access):
        """Sets the has_task_write_access of this AccessData.


        :param has_task_write_access: The has_task_write_access of this AccessData.  # noqa: E501
        :type: bool
        """
        if has_task_write_access is None:
            raise ValueError("Invalid value for `has_task_write_access`, must not be `None`")  # noqa: E501

        self._has_task_write_access = has_task_write_access

    @property
    def has_read_access(self):
        """Gets the has_read_access of this AccessData.  # noqa: E501


        :return: The has_read_access of this AccessData.  # noqa: E501
        :rtype: bool
        """
        return self._has_read_access

    @has_read_access.setter
    def has_read_access(self, has_read_access):
        """Sets the has_read_access of this AccessData.


        :param has_read_access: The has_read_access of this AccessData.  # noqa: E501
        :type: bool
        """
        if has_read_access is None:
            raise ValueError("Invalid value for `has_read_access`, must not be `None`")  # noqa: E501

        self._has_read_access = has_read_access

    @property
    def has_write_access(self):
        """Gets the has_write_access of this AccessData.  # noqa: E501


        :return: The has_write_access of this AccessData.  # noqa: E501
        :rtype: bool
        """
        return self._has_write_access

    @has_write_access.setter
    def has_write_access(self, has_write_access):
        """Sets the has_write_access of this AccessData.


        :param has_write_access: The has_write_access of this AccessData.  # noqa: E501
        :type: bool
        """
        if has_write_access is None:
            raise ValueError("Invalid value for `has_write_access`, must not be `None`")  # noqa: E501

        self._has_write_access = has_write_access

    @property
    def has_administrator_access(self):
        """Gets the has_administrator_access of this AccessData.  # noqa: E501


        :return: The has_administrator_access of this AccessData.  # noqa: E501
        :rtype: bool
        """
        return self._has_administrator_access

    @has_administrator_access.setter
    def has_administrator_access(self, has_administrator_access):
        """Sets the has_administrator_access of this AccessData.


        :param has_administrator_access: The has_administrator_access of this AccessData.  # noqa: E501
        :type: bool
        """
        if has_administrator_access is None:
            raise ValueError("Invalid value for `has_administrator_access`, must not be `None`")  # noqa: E501

        self._has_administrator_access = has_administrator_access

    @property
    def has_import_access(self):
        """Gets the has_import_access of this AccessData.  # noqa: E501


        :return: The has_import_access of this AccessData.  # noqa: E501
        :rtype: bool
        """
        return self._has_import_access

    @has_import_access.setter
    def has_import_access(self, has_import_access):
        """Sets the has_import_access of this AccessData.


        :param has_import_access: The has_import_access of this AccessData.  # noqa: E501
        :type: bool
        """
        if has_import_access is None:
            raise ValueError("Invalid value for `has_import_access`, must not be `None`")  # noqa: E501

        self._has_import_access = has_import_access

    @property
    def has_export_access(self):
        """Gets the has_export_access of this AccessData.  # noqa: E501


        :return: The has_export_access of this AccessData.  # noqa: E501
        :rtype: bool
        """
        return self._has_export_access

    @has_export_access.setter
    def has_export_access(self, has_export_access):
        """Sets the has_export_access of this AccessData.


        :param has_export_access: The has_export_access of this AccessData.  # noqa: E501
        :type: bool
        """
        if has_export_access is None:
            raise ValueError("Invalid value for `has_export_access`, must not be `None`")  # noqa: E501

        self._has_export_access = has_export_access

    @property
    def has_delete_access(self):
        """Gets the has_delete_access of this AccessData.  # noqa: E501


        :return: The has_delete_access of this AccessData.  # noqa: E501
        :rtype: bool
        """
        return self._has_delete_access

    @has_delete_access.setter
    def has_delete_access(self, has_delete_access):
        """Sets the has_delete_access of this AccessData.


        :param has_delete_access: The has_delete_access of this AccessData.  # noqa: E501
        :type: bool
        """
        if has_delete_access is None:
            raise ValueError("Invalid value for `has_delete_access`, must not be `None`")  # noqa: E501

        self._has_delete_access = has_delete_access

    @property
    def has_create_access(self):
        """Gets the has_create_access of this AccessData.  # noqa: E501


        :return: The has_create_access of this AccessData.  # noqa: E501
        :rtype: bool
        """
        return self._has_create_access

    @has_create_access.setter
    def has_create_access(self, has_create_access):
        """Sets the has_create_access of this AccessData.


        :param has_create_access: The has_create_access of this AccessData.  # noqa: E501
        :type: bool
        """
        if has_create_access is None:
            raise ValueError("Invalid value for `has_create_access`, must not be `None`")  # noqa: E501

        self._has_create_access = has_create_access

    @property
    def has_management_access(self):
        """Gets the has_management_access of this AccessData.  # noqa: E501


        :return: The has_management_access of this AccessData.  # noqa: E501
        :rtype: bool
        """
        return self._has_management_access

    @has_management_access.setter
    def has_management_access(self, has_management_access):
        """Sets the has_management_access of this AccessData.


        :param has_management_access: The has_management_access of this AccessData.  # noqa: E501
        :type: bool
        """
        if has_management_access is None:
            raise ValueError("Invalid value for `has_management_access`, must not be `None`")  # noqa: E501

        self._has_management_access = has_management_access

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(AccessData, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AccessData):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
