# coding: utf-8

"""
    Developer API - DataGalaxy

    # Overview  The DataGalaxy API gives you access to CRUD actions on your metamodel, users and licenses.  Our API is organized around REST. It accepts and returns JSON-encoded data, and uses standard HTTP response codes, verbs and authentication with access tokens.  To get the full picture of DataGalaxy, please feel free to consult our <a href='https://datagalaxy.freshdesk.com/solution/articles/35000131583--basics-datagalaxy-s-main-concepts-/en' target='_new'>online documentation.</a><br/> Have a look at our <a href='https://datagalaxy.freshdesk.com/en/support/solutions/articles/35000151096--quick-start-datagalaxy-public-api-v2' target='_new'>step by step guide</a> for a quick start on how to use our API.  ## Response Status Codes  | Status Code  | Description       | Notes | | ------------ | ----------------- | ----- | | 200          | OK                | The request was successful | | 400          | Bad Request       | Incoming request contains parameters that might not be valid | | 401          | Unauthorized      | The supplied credentials, if any, are not sufficient to access the resource | | 404          | Not Found         | The requested resource is not found | | 429          | Too Many Requests | Too many requests have been (Rate limiting) | | 500          | Server Error      | The server could not return the representation due to an internal server error | | 501          | Not Implemented   | The requested operation is not supported (e.g. supports GET but not POST etc.) |  ## Rate Limits  The DataGalaxy API has 2 kinds of limitations: rate limiting and throttling.  <b>Pro tip:</b> You can track your rate limiting status with the response header `X-RateLimit-Remaining`. It will display how many requests you can send until the next reset.  | Method        | Rate                 | Note | | ------------- | -------------------- | ---- | | Rate limiting | 7200 requests / hour | When exceeded, your IP will be blocked for 15 minutes. | | Throttling    | 2 requests / second  | When exceeded, each request will be delayed by 500ms. | | Payload size  | 100 MB               | When exceeded, request will be rejected. |  ## Pagination  All routes returning lists share the same pagination format. These routes take two optional parameters as querystrings: <code>limit</code> and <code>page</code>.<br>  | QueryString | Definition | |------------ | ---------- | | limit       | Integer ranging from 1 to 5000. It sets the maximum amount of objects per page. Default value is 20. | | page        | Integer starting at 1. It determines the page returned by the request. Default value is 1. |  The response payload contains 5 properties:  | Property  | Definition | | --------- | ---------- | | pages     | Total number of pages. | | total     | Number of objects returned. | | total_sum | Sum of all existing objects. | | next_page | URL of the next page. <i>Value will be null if there is none.</i> | | results   | List of objects. |  # Authentication  The DataGalaxy API uses <b>Bearer Authentication</b> to authenticate requests. Every request must contain an <code>Authorization</code> header with, either an <i>AccessToken</i> or an <i>IntegrationToken</i>.  ## AccessToken  Here is a quick example using CURL:  <pre><code>curl -X GET \"https://api.datagalaxy.com/v2/workspaces\" -H \"Authorization: Bearer <i>AccessToken</i>\"</code></pre>  The first steps of our <a href='https://datagalaxy.freshdesk.com/en/support/solutions/articles/35000151096--quick-start-datagalaxy-public-api-v2' target='_new'>quick start guide</a> will give you instructions to obtain your <code>accesstoken</code>.  ## IntegrationToken  An integration token can be generated from the \"Integration\" page on the DataGalaxy Administration space.  <pre><code>curl -X GET \"https://api.datagalaxy.com/v2/workspaces\" -H \"Authorization: Bearer <i>IntegrationToken</i>\"</code></pre>  # Changelog  The DataGalaxy Developer API is updated frequently with new features, improvements and fixes.  All these changes will be documented in our <button><a href='/v2/documentation/changelog' target='_blank'><b>changelog</b></a></button>.  # Documentation layout  We provide two API documentation layouts:  - [Default layout](/v2/documentation)<br> This layout displays informations in a modern way and contains more informations about requests parameters - [Swagger layout](/v2/documentation/old)<br> This is our legacy layout. It's main perk is the \"Try it\" feature which let's you send requests directly from the documentation.  # noqa: E501

    OpenAPI spec version: 2.12.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class License(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'license_id': 'float',
        'license_level': 'str',
        'starts_on': 'str',
        'expires_on': 'str',
        'status': 'str',
        'associate_user': 'str',
        'is_expired': 'bool',
        'creation_time': 'str',
        'last_modification_time': 'str',
        'is_license_pool': 'bool',
        'available_licenses': 'float'
    }

    attribute_map = {
        'license_id': 'licenseId',
        'license_level': 'licenseLevel',
        'starts_on': 'startsOn',
        'expires_on': 'expiresOn',
        'status': 'status',
        'associate_user': 'associateUser',
        'is_expired': 'isExpired',
        'creation_time': 'creationTime',
        'last_modification_time': 'lastModificationTime',
        'is_license_pool': 'isLicensePool',
        'available_licenses': 'availableLicenses'
    }

    def __init__(self, license_id=None, license_level=None, starts_on=None, expires_on=None, status=None, associate_user=None, is_expired=None, creation_time=None, last_modification_time=None, is_license_pool=None, available_licenses=None):  # noqa: E501
        """License - a model defined in Swagger"""  # noqa: E501
        self._license_id = None
        self._license_level = None
        self._starts_on = None
        self._expires_on = None
        self._status = None
        self._associate_user = None
        self._is_expired = None
        self._creation_time = None
        self._last_modification_time = None
        self._is_license_pool = None
        self._available_licenses = None
        self.discriminator = None
        self.license_id = license_id
        self.license_level = license_level
        self.starts_on = starts_on
        self.expires_on = expires_on
        self.status = status
        self.associate_user = associate_user
        self.is_expired = is_expired
        self.creation_time = creation_time
        self.last_modification_time = last_modification_time
        self.is_license_pool = is_license_pool
        if available_licenses is not None:
            self.available_licenses = available_licenses

    @property
    def license_id(self):
        """Gets the license_id of this License.  # noqa: E501


        :return: The license_id of this License.  # noqa: E501
        :rtype: float
        """
        return self._license_id

    @license_id.setter
    def license_id(self, license_id):
        """Sets the license_id of this License.


        :param license_id: The license_id of this License.  # noqa: E501
        :type: float
        """
        if license_id is None:
            raise ValueError("Invalid value for `license_id`, must not be `None`")  # noqa: E501

        self._license_id = license_id

    @property
    def license_level(self):
        """Gets the license_level of this License.  # noqa: E501


        :return: The license_level of this License.  # noqa: E501
        :rtype: str
        """
        return self._license_level

    @license_level.setter
    def license_level(self, license_level):
        """Sets the license_level of this License.


        :param license_level: The license_level of this License.  # noqa: E501
        :type: str
        """
        if license_level is None:
            raise ValueError("Invalid value for `license_level`, must not be `None`")  # noqa: E501

        self._license_level = license_level

    @property
    def starts_on(self):
        """Gets the starts_on of this License.  # noqa: E501


        :return: The starts_on of this License.  # noqa: E501
        :rtype: str
        """
        return self._starts_on

    @starts_on.setter
    def starts_on(self, starts_on):
        """Sets the starts_on of this License.


        :param starts_on: The starts_on of this License.  # noqa: E501
        :type: str
        """
        if starts_on is None:
            raise ValueError("Invalid value for `starts_on`, must not be `None`")  # noqa: E501

        self._starts_on = starts_on

    @property
    def expires_on(self):
        """Gets the expires_on of this License.  # noqa: E501


        :return: The expires_on of this License.  # noqa: E501
        :rtype: str
        """
        return self._expires_on

    @expires_on.setter
    def expires_on(self, expires_on):
        """Sets the expires_on of this License.


        :param expires_on: The expires_on of this License.  # noqa: E501
        :type: str
        """
        if expires_on is None:
            raise ValueError("Invalid value for `expires_on`, must not be `None`")  # noqa: E501

        self._expires_on = expires_on

    @property
    def status(self):
        """Gets the status of this License.  # noqa: E501


        :return: The status of this License.  # noqa: E501
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this License.


        :param status: The status of this License.  # noqa: E501
        :type: str
        """
        if status is None:
            raise ValueError("Invalid value for `status`, must not be `None`")  # noqa: E501

        self._status = status

    @property
    def associate_user(self):
        """Gets the associate_user of this License.  # noqa: E501


        :return: The associate_user of this License.  # noqa: E501
        :rtype: str
        """
        return self._associate_user

    @associate_user.setter
    def associate_user(self, associate_user):
        """Sets the associate_user of this License.


        :param associate_user: The associate_user of this License.  # noqa: E501
        :type: str
        """
        if associate_user is None:
            raise ValueError("Invalid value for `associate_user`, must not be `None`")  # noqa: E501

        self._associate_user = associate_user

    @property
    def is_expired(self):
        """Gets the is_expired of this License.  # noqa: E501


        :return: The is_expired of this License.  # noqa: E501
        :rtype: bool
        """
        return self._is_expired

    @is_expired.setter
    def is_expired(self, is_expired):
        """Sets the is_expired of this License.


        :param is_expired: The is_expired of this License.  # noqa: E501
        :type: bool
        """
        if is_expired is None:
            raise ValueError("Invalid value for `is_expired`, must not be `None`")  # noqa: E501

        self._is_expired = is_expired

    @property
    def creation_time(self):
        """Gets the creation_time of this License.  # noqa: E501


        :return: The creation_time of this License.  # noqa: E501
        :rtype: str
        """
        return self._creation_time

    @creation_time.setter
    def creation_time(self, creation_time):
        """Sets the creation_time of this License.


        :param creation_time: The creation_time of this License.  # noqa: E501
        :type: str
        """
        if creation_time is None:
            raise ValueError("Invalid value for `creation_time`, must not be `None`")  # noqa: E501

        self._creation_time = creation_time

    @property
    def last_modification_time(self):
        """Gets the last_modification_time of this License.  # noqa: E501


        :return: The last_modification_time of this License.  # noqa: E501
        :rtype: str
        """
        return self._last_modification_time

    @last_modification_time.setter
    def last_modification_time(self, last_modification_time):
        """Sets the last_modification_time of this License.


        :param last_modification_time: The last_modification_time of this License.  # noqa: E501
        :type: str
        """
        if last_modification_time is None:
            raise ValueError("Invalid value for `last_modification_time`, must not be `None`")  # noqa: E501

        self._last_modification_time = last_modification_time

    @property
    def is_license_pool(self):
        """Gets the is_license_pool of this License.  # noqa: E501


        :return: The is_license_pool of this License.  # noqa: E501
        :rtype: bool
        """
        return self._is_license_pool

    @is_license_pool.setter
    def is_license_pool(self, is_license_pool):
        """Sets the is_license_pool of this License.


        :param is_license_pool: The is_license_pool of this License.  # noqa: E501
        :type: bool
        """
        if is_license_pool is None:
            raise ValueError("Invalid value for `is_license_pool`, must not be `None`")  # noqa: E501

        self._is_license_pool = is_license_pool

    @property
    def available_licenses(self):
        """Gets the available_licenses of this License.  # noqa: E501


        :return: The available_licenses of this License.  # noqa: E501
        :rtype: float
        """
        return self._available_licenses

    @available_licenses.setter
    def available_licenses(self, available_licenses):
        """Sets the available_licenses of this License.


        :param available_licenses: The available_licenses of this License.  # noqa: E501
        :type: float
        """

        self._available_licenses = available_licenses

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(License, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, License):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
