# coding: utf-8

"""
    Developer API - DataGalaxy

    # Overview  The DataGalaxy API gives you access to CRUD actions on your metamodel, users and licenses.  Our API is organized around REST. It accepts and returns JSON-encoded data, and uses standard HTTP response codes, verbs and authentication with access tokens.  To get the full picture of DataGalaxy, please feel free to consult our <a href='https://datagalaxy.freshdesk.com/solution/articles/35000131583--basics-datagalaxy-s-main-concepts-/en' target='_new'>online documentation.</a><br/> Have a look at our <a href='https://datagalaxy.freshdesk.com/en/support/solutions/articles/35000151096--quick-start-datagalaxy-public-api-v2' target='_new'>step by step guide</a> for a quick start on how to use our API.  ## Response Status Codes  | Status Code  | Description       | Notes | | ------------ | ----------------- | ----- | | 200          | OK                | The request was successful | | 400          | Bad Request       | Incoming request contains parameters that might not be valid | | 401          | Unauthorized      | The supplied credentials, if any, are not sufficient to access the resource | | 404          | Not Found         | The requested resource is not found | | 429          | Too Many Requests | Too many requests have been (Rate limiting) | | 500          | Server Error      | The server could not return the representation due to an internal server error | | 501          | Not Implemented   | The requested operation is not supported (e.g. supports GET but not POST etc.) |  ## Rate Limits  The DataGalaxy API has 2 kinds of limitations: rate limiting and throttling.  <b>Pro tip:</b> You can track your rate limiting status with the response header `X-RateLimit-Remaining`. It will display how many requests you can send until the next reset.  | Method        | Rate                 | Note | | ------------- | -------------------- | ---- | | Rate limiting | 7200 requests / hour | When exceeded, your IP will be blocked for 15 minutes. | | Throttling    | 2 requests / second  | When exceeded, each request will be delayed by 500ms. | | Payload size  | 100 MB               | When exceeded, request will be rejected. |  ## Pagination  All routes returning lists share the same pagination format. These routes take two optional parameters as querystrings: <code>limit</code> and <code>page</code>.<br>  | QueryString | Definition | |------------ | ---------- | | limit       | Integer ranging from 1 to 5000. It sets the maximum amount of objects per page. Default value is 20. | | page        | Integer starting at 1. It determines the page returned by the request. Default value is 1. |  The response payload contains 5 properties:  | Property  | Definition | | --------- | ---------- | | pages     | Total number of pages. | | total     | Number of objects returned. | | total_sum | Sum of all existing objects. | | next_page | URL of the next page. <i>Value will be null if there is none.</i> | | results   | List of objects. |  # Authentication  The DataGalaxy API uses <b>Bearer Authentication</b> to authenticate requests. Every request must contain an <code>Authorization</code> header with, either an <i>AccessToken</i> or an <i>IntegrationToken</i>.  ## AccessToken  Here is a quick example using CURL:  <pre><code>curl -X GET \"https://api.datagalaxy.com/v2/workspaces\" -H \"Authorization: Bearer <i>AccessToken</i>\"</code></pre>  The first steps of our <a href='https://datagalaxy.freshdesk.com/en/support/solutions/articles/35000151096--quick-start-datagalaxy-public-api-v2' target='_new'>quick start guide</a> will give you instructions to obtain your <code>accesstoken</code>.  ## IntegrationToken  An integration token can be generated from the \"Integration\" page on the DataGalaxy Administration space.  <pre><code>curl -X GET \"https://api.datagalaxy.com/v2/workspaces\" -H \"Authorization: Bearer <i>IntegrationToken</i>\"</code></pre>  # Changelog  The DataGalaxy Developer API is updated frequently with new features, improvements and fixes.  All these changes will be documented in our <button><a href='/v2/documentation/changelog' target='_blank'><b>changelog</b></a></button>.  # Documentation layout  We provide two API documentation layouts:  - [Default layout](/v2/documentation)<br> This layout displays informations in a modern way and contains more informations about requests parameters - [Swagger layout](/v2/documentation/old)<br> This is our legacy layout. It's main perk is the \"Try it\" feature which let's you send requests directly from the documentation.  # noqa: E501

    OpenAPI spec version: 2.12.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class SCIMUser(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'schemas': 'str',
        'id': 'Uuid',
        'meta': 'SCIMUserMeta',
        'user_name': 'Email',
        'name': 'SCIMUserName',
        'active': 'bool',
        'emails': 'list[SCIMUserEmails]',
        'photos': 'list[SCIMUserPhotos]'
    }

    attribute_map = {
        'schemas': 'schemas',
        'id': 'id',
        'meta': 'meta',
        'user_name': 'userName',
        'name': 'name',
        'active': 'active',
        'emails': 'emails',
        'photos': 'photos'
    }

    def __init__(self, schemas=None, id=None, meta=None, user_name=None, name=None, active=None, emails=None, photos=None):  # noqa: E501
        """SCIMUser - a model defined in Swagger"""  # noqa: E501
        self._schemas = None
        self._id = None
        self._meta = None
        self._user_name = None
        self._name = None
        self._active = None
        self._emails = None
        self._photos = None
        self.discriminator = None
        self.schemas = schemas
        if id is not None:
            self.id = id
        if meta is not None:
            self.meta = meta
        self.user_name = user_name
        self.name = name
        if active is not None:
            self.active = active
        self.emails = emails
        if photos is not None:
            self.photos = photos

    @property
    def schemas(self):
        """Gets the schemas of this SCIMUser.  # noqa: E501


        :return: The schemas of this SCIMUser.  # noqa: E501
        :rtype: str
        """
        return self._schemas

    @schemas.setter
    def schemas(self, schemas):
        """Sets the schemas of this SCIMUser.


        :param schemas: The schemas of this SCIMUser.  # noqa: E501
        :type: str
        """
        if schemas is None:
            raise ValueError("Invalid value for `schemas`, must not be `None`")  # noqa: E501
        allowed_values = ["urn:ietf:params:scim:schemas:core:2.0:User"]  # noqa: E501
        if schemas not in allowed_values:
            raise ValueError(
                "Invalid value for `schemas` ({0}), must be one of {1}"  # noqa: E501
                .format(schemas, allowed_values)
            )

        self._schemas = schemas

    @property
    def id(self):
        """Gets the id of this SCIMUser.  # noqa: E501


        :return: The id of this SCIMUser.  # noqa: E501
        :rtype: Uuid
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this SCIMUser.


        :param id: The id of this SCIMUser.  # noqa: E501
        :type: Uuid
        """

        self._id = id

    @property
    def meta(self):
        """Gets the meta of this SCIMUser.  # noqa: E501


        :return: The meta of this SCIMUser.  # noqa: E501
        :rtype: SCIMUserMeta
        """
        return self._meta

    @meta.setter
    def meta(self, meta):
        """Sets the meta of this SCIMUser.


        :param meta: The meta of this SCIMUser.  # noqa: E501
        :type: SCIMUserMeta
        """

        self._meta = meta

    @property
    def user_name(self):
        """Gets the user_name of this SCIMUser.  # noqa: E501


        :return: The user_name of this SCIMUser.  # noqa: E501
        :rtype: Email
        """
        return self._user_name

    @user_name.setter
    def user_name(self, user_name):
        """Sets the user_name of this SCIMUser.


        :param user_name: The user_name of this SCIMUser.  # noqa: E501
        :type: Email
        """
        if user_name is None:
            raise ValueError("Invalid value for `user_name`, must not be `None`")  # noqa: E501

        self._user_name = user_name

    @property
    def name(self):
        """Gets the name of this SCIMUser.  # noqa: E501


        :return: The name of this SCIMUser.  # noqa: E501
        :rtype: SCIMUserName
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this SCIMUser.


        :param name: The name of this SCIMUser.  # noqa: E501
        :type: SCIMUserName
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def active(self):
        """Gets the active of this SCIMUser.  # noqa: E501


        :return: The active of this SCIMUser.  # noqa: E501
        :rtype: bool
        """
        return self._active

    @active.setter
    def active(self, active):
        """Sets the active of this SCIMUser.


        :param active: The active of this SCIMUser.  # noqa: E501
        :type: bool
        """

        self._active = active

    @property
    def emails(self):
        """Gets the emails of this SCIMUser.  # noqa: E501


        :return: The emails of this SCIMUser.  # noqa: E501
        :rtype: list[SCIMUserEmails]
        """
        return self._emails

    @emails.setter
    def emails(self, emails):
        """Sets the emails of this SCIMUser.


        :param emails: The emails of this SCIMUser.  # noqa: E501
        :type: list[SCIMUserEmails]
        """
        if emails is None:
            raise ValueError("Invalid value for `emails`, must not be `None`")  # noqa: E501

        self._emails = emails

    @property
    def photos(self):
        """Gets the photos of this SCIMUser.  # noqa: E501


        :return: The photos of this SCIMUser.  # noqa: E501
        :rtype: list[SCIMUserPhotos]
        """
        return self._photos

    @photos.setter
    def photos(self, photos):
        """Sets the photos of this SCIMUser.


        :param photos: The photos of this SCIMUser.  # noqa: E501
        :type: list[SCIMUserPhotos]
        """

        self._photos = photos

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(SCIMUser, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SCIMUser):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
